Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 636934

Summary: <sys-libs/glibc-2.26[rpc] installs old /usr/include/rpcsvc/rquota.{x,h} which clash with sys-fs/quota[rpc]
Product: Gentoo Linux Reporter: Maciej S. Szmigiero <mail>
Component: Current packagesAssignee: Gentoo Toolchain Maintainers <toolchain>
Status: RESOLVED FIXED    
Severity: normal CC: base-system
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
Whiteboard:
Package list:
Runtime testing required: ---

Description Maciej S. Szmigiero 2017-11-08 22:36:04 UTC
Emerging sys-fs/quota[rpc] fails with the following file collisions:
 * Detected file collision(s):
 * 
 *      /usr/include/rpcsvc/rquota.h
 *      /usr/include/rpcsvc/rquota.x
 * 
 * Searching all installed packages for file collisions...
 * 
 * Press Ctrl-C to Stop
 * 
 * sys-libs/glibc-2.25-r9:2.2::gentoo
 *      /usr/include/rpcsvc/rquota.h
 *      /usr/include/rpcsvc/rquota.x
 * 
 * Package 'sys-fs/quota-4.04-r1' NOT merged due to file collisions. If
 * necessary, refer to your elog messages for the whole content of the
 * above message.

Since glibc-provided rquota.{x,h} files are clearly less complete than these
provided by sys-fs/quota a simple fix is to disable installation of these files
on the glibc side:
--- a/sunrpc/Makefile   2017-11-08 22:52:19.855669799 +0100
+++ b/sunrpc/Makefile   2017-11-08 22:53:18.813436479 +0100
@@ -47,7 +47,7 @@
 
 rpcsvc = bootparam_prot.x nlm_prot.x rstat.x \
         yppasswd.x klm_prot.x rex.x sm_inter.x mount.x \
-        rusers.x spray.x nfs_prot.x rquota.x key_prot.x
+        rusers.x spray.x nfs_prot.x key_prot.x
 headers-in-tirpc = $(addprefix rpc/,auth.h auth_unix.h clnt.h pmap_clnt.h \
                                    pmap_prot.h pmap_rmt.h rpc.h rpc_msg.h \
                                    svc.h svc_auth.h types.h xdr.h auth_des.h \


After recompiling glibc with this patch the sys-fs/quota package installs
successfully.

Note that disabling glibc rpc USE flag disables all sunrpc support, not only
for the rquota protocol.
This USE flag also has a comment that "disabling [it] is experimental".
Comment 1 Andreas K. Hüttel gentoo-dev 2017-11-11 15:37:00 UTC
> 
> After recompiling glibc with this patch the sys-fs/quota package installs
> successfully.

Predictable problem... However I'm not going to drop the files from old glibc versions since packages expect them to be there. 

> Note that disabling glibc rpc USE flag disables all sunrpc support, not only
> for the rquota protocol.
> This USE flag also has a comment that "disabling [it] is experimental".

That's by now wrong. It may be a bit experimental for Gentoo, but upstream the SunRPC code in glibc is deprecated since ages. 

And with sys-libs/glibc-2.26, the RPC code in glibc is gone anyway.

My suggestion would be, live with it somehow and wait until glibc-2.26 is keyworded, then carefully update to that. (This should happen pretty soon.)
Comment 2 Maciej S. Szmigiero 2017-11-12 01:26:44 UTC
(In reply to Andreas K. Hüttel from comment #1)
(..)
> My suggestion would be, live with it somehow and wait until glibc-2.26 is
> keyworded, then carefully update to that. (This should happen pretty soon.)

It would be great if then an appropriate dependency could be added to the
sys-fs/quota package (when it has "rpc" USE flag enabled) so people with an older
version of glibc installed will know they'll need to update it for this package to install successfully (it isn't nice when leaving a PC for a night to do a
100-package update only to discover in the morning that it failed on 12th package
because its dependencies weren't correctly specified).
Comment 3 Larry the Git Cow gentoo-dev 2017-11-12 14:16:26 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=02056778ea5961e77a59a7a246b355c1225c7404

commit 02056778ea5961e77a59a7a246b355c1225c7404
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2017-11-12 12:28:38 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2017-11-12 14:15:28 +0000

    sys-libs/glibc: Re-add keywords to glibc 2.26
    
    Bug: https://bugs.gentoo.org/492814
    Bug: https://bugs.gentoo.org/622694
    Bug: https://bugs.gentoo.org/617938
    Bug: https://bugs.gentoo.org/466176
    Bug: https://bugs.gentoo.org/628768
    Bug: https://bugs.gentoo.org/637016
    Bug: https://bugs.gentoo.org/636934
    Bug: https://bugs.gentoo.org/381391
    Bug: https://bugs.gentoo.org/636158
    Package-Manager: Portage-2.3.13, Repoman-2.3.4

 sys-libs/glibc/glibc-2.26-r3.ebuild | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)}
Comment 4 Larry the Git Cow gentoo-dev 2017-12-15 21:57:46 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5c3844421221d5f61665773f9f6f3497764609c8

commit 5c3844421221d5f61665773f9f6f3497764609c8
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2017-12-15 21:57:10 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2017-12-15 21:57:37 +0000

    sys-libs/glibc: Fix useflag rpc description, disabling should no longer be experimental
    
    Bug: https://bugs.gentoo.org/636934
    Package-Manager: Portage-2.3.18, Repoman-2.3.6

 sys-libs/glibc/metadata.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)}
Comment 5 Larry the Git Cow gentoo-dev 2017-12-18 19:34:08 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ec1d210e7d85aba515fe6519601c95f03337ade2

commit ec1d210e7d85aba515fe6519601c95f03337ade2
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2017-12-18 19:33:40 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2017-12-18 19:33:59 +0000

    sys-fs/quota: Require glibc without rpc support if rpc support is selected here, bug 636934
    
    Otherwise we get file collisions:
     * sys-libs/glibc-2.25-r9:2.2::gentoo
     *      /usr/include/rpcsvc/rquota.h
     *      /usr/include/rpcsvc/rquota.x
    
    Closes: https://bugs.gentoo.org/636934
    Package-Manager: Portage-2.3.19, Repoman-2.3.6

 sys-fs/quota/quota-4.04-r1.ebuild |  8 ++--
 sys-fs/quota/quota-4.04.ebuild    | 79 ---------------------------------------
 2 files changed, 3 insertions(+), 84 deletions(-)